import React, { PureComponent, MouseEvent, TouchEvent } from 'react';
import { GlarePosition } from './features/Glare';
declare type DOMSupportedEvent = MouseEvent<HTMLDivElement> | TouchEvent | DeviceOrientationEvent;
declare type SupportedEvent = DOMSupportedEvent | CustomEvent<CustomEventType>;
declare type CustomEventType = 'autoreset' | 'propchange';
declare type Axis = 'x' | 'y';
export declare type TiltProps = {
    tiltEnable?: boolean;
    tiltReverse?: boolean;
    tiltMaxAngleX?: number;
    tiltMaxAngleY?: number;
    tiltAxis?: Axis | null;
    tiltAngleXManual?: number | null;
    tiltAngleYManual?: number | null;
};
export declare type GlareProps = {
    glareEnable?: boolean;
    glareMaxOpacity?: number;
    glareColor?: string;
    glarePosition?: GlarePosition;
    glareReverse?: boolean;
};
export interface Props extends TiltProps, GlareProps, React.HTMLAttributes<HTMLDivElement> {
    scale?: number;
    perspective?: number;
    flipVertically?: boolean;
    flipHorizontally?: boolean;
    reset?: boolean;
    transitionEasing?: string;
    transitionSpeed?: number;
    gyroscope?: boolean;
    onMove?: (tiltAngleX: number, tiltAngleY: number, tiltAngleXPercentage: number, tiltAngleYPercentage: number, glareAngle: number, glareOpacity: number, eventType: string | null) => void;
    onEnter?: (eventType: string) => void;
    onLeave?: (eventType: string) => void;
}
declare class ReactParallaxTilt extends PureComponent<Props> {
    static defaultProps: Props;
    private wrapperEl;
    private tilt;
    private glare;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(): void;
    private addEventListeners;
    private removeEventListeners;
    private initGlare;
    mainLoop: (event: SupportedEvent) => void;
    onWindowResize: () => void;
    private setWrapperElSize;
    private onEnter;
    private onMove;
    private onLeave;
    private processInput;
    private processInputDeviceOrientation;
    private update;
    private updateClientInput;
    private updateFlip;
    renderFrame: () => void;
    private resetWrapperElTransform;
    private renderPerspective;
    private renderScale;
    private setTransition;
    render(): JSX.Element;
}
export default ReactParallaxTilt;
